/*
 * T.C.F.S. 2.0 
 *
 *              This  program  handles  RPC  "NFS"  data  requests
 *              adopting a secure transfer protocol.
 *              This   is  an  unsecure   and  unchecked  version,
 *              use at your own risk.
 *
 *              Please, report Bugs to: <tcfs@edu-gw.dia.unisa.it>
 *
 * Authors:	Giuseppe Cattaneo, <cattaneo@udsab.dia.unisa.it>
 *		Giuseppe Persiano, <giuper@udsab.dia.unisa.it>
 *		Andrea Cozzolino, <andcoz@edu-gw.dia.unisa.it>
 *		Angelo Celentano, <angcel@edu-gw.dia.unisa.it>
 *		Aniello Del Sorbo, <anidel@edu-gw.dia.unisa.it>
 *		Ermelindo Mauriello, <ermmau@edu-gw.dia.unisa.it>
 *		Raffaele Pisapia, <rafpis@edu-gw.dia.unisa.it>
 *
 *   Permission to  use, copy, and modify  this software  without fee
 * is hereby granted, provided that this entire notice is included in
 * all copies  of  any  software  which  is  or  includes a  copy  or
 * modification of this software and in all copies  of the supporting
 * documentation for such software.
 *
 *   This  software is  distribuited  under  the  GNU General  Public
 * License  (version  2, June  1991). Check  the  file  'COPING'  for
 * more  infos. Some  parts of  this  software  derive  from the  NFS
 * implementation in the Linux kernel 2.0.x.
 *
 * This software  maybe be used  for any  purpose provided  the above
 * copyright  notice  is retained.  It  is  supplied  as is,  with no
 * warranty expressed or implied.
 *
 */

/* -+-_== */

#ifndef _LINUX_IDEA_H
#define _LINUX_IDEA_H

#define IDEA_AVAILABLE

typedef unsigned idea_cblock[10];

typedef struct idea_ks_struct
	{
		idea_cblock _;
	} idea_key_schedule[7];

#ifndef _LINUX_IDEA_IF
extern int idea_encrypt(char *input,idea_key_schedule ks);
extern int idea_decrypt(char *input,idea_key_schedule ks);
extern void idea_set_key(char *key,idea_key_schedule schedule);
extern void cip_octets(unsigned char *, unsigned * );
#endif

extern void idea_cip(unsigned *,unsigned *,unsigned *);

extern void idea_key(char *,unsigned *);
extern void idea_de_key(unsigned *,unsigned *);

#endif
